您的位置:首页 > 其它

CodeForces-688C.NP-Hard Problem

2016-08-08 23:03 375 查看
Recently, Pari and Arya did some research about NP-Hard problems and they found the minimum vertex cover problem very interesting.

Suppose the graph G is given. Subset A of its vertices is called a vertex cover of this graph, if for each edge uv there is at least one endpoint of it in this set, i.e. or (or both).

Pari and Arya have won a great undirected graph as an award in a team contest. Now they have to split it in two parts, but both of them want their parts of the graph to be a vertex cover.

They have agreed to give you their graph and you need to find two disjoint subsets of its vertices A and B, such that both A and B are vertex cover or claim it’s impossible. Each vertex should be given to no more than one of the friends (or you can even keep it for yourself).

Input

The first line of the input contains two integers n and m (2 ≤ n ≤ 100 000, 1 ≤ m ≤ 100 000) — the number of vertices and the number of edges in the prize graph, respectively.

Each of the next m lines contains a pair of integers ui and vi (1  ≤  ui,  vi  ≤  n), denoting an undirected edge between ui and vi. It’s guaranteed the graph won’t contain any self-loops or multiple edges.

Output

If it’s impossible to split the graph between Pari and Arya as they expect, print “-1” (without quotes).

If there are two disjoint sets of vertices, such that both sets are vertex cover, print their descriptions. Each description must contain two lines. The first line contains a single integer k denoting the number of vertices in that vertex cover, and the second line contains k integers — the indices of vertices. Note that because of m ≥ 1, vertex cover cannot be empty.

Examples

input

4 2

1 2

2 3

output

1

2

2

1 3

input

3 3

1 2

2 3

1 3

output

-1

Note

In the first sample, you can give the vertex number 2 to Arya and vertices numbered 1 and 3 to Pari and keep vertex number 4 for yourself (or give it someone, if you wish).

In the second sample, there is no way to satisfy both Pari and Arya.

题意:给定顶点和边,将顶点分为两组,同一组的任意两顶点不能相连。输出两组的各点,若不能分,输出-1。

题解:一个一个顶点进行搜索,如果一个顶点没有被分组,假设在A组,那么与之相连的点一定在B组。

#include<iostream>
#include<queue>
#include<string.h>
using namespace std;
int n, m, a, b;
int Judge[100010], A[100005], B[100005];
typedef struct Node {
struct Node* next;
int num;
}Node;
struct {
Node* first;
}Graph[100005];
void Init()
{
memset(Judge, 0, sizeof(Judge));
for (int i = 1; i <= n; i++)
Graph[i].first = NULL;
}
void Insert(int x, int y)
{
Node *p=new Node, *q=new Node;
p->num = y;
p->next = Graph[x].first;
Graph[x].first = p;
q->num = x;
q->next = Graph[y].first;
Graph[y].first = q;
}
bool Bfs()
{
a = 0; b = 0;
Node *p;
bool judge = true;
queue<int>que;
for (int i = 1; i <= n&&judge; i++)
{
que.push(i);
while (!que.empty())
{
int k = que.front();
que.pop();
if (!Judge[k])
{
p = Graph[k].first;
if (p)
{
A[a++] = k;
Judge[k] = 1;
}
while (p)
{
B[b++] = p->num;
Judge[p->num] = 2;
que.push(p->num);
p = p->next;
}
}
else if (Judge[k] == 1)
{
p = Graph[k].first;
while (p)
{
if (Judge[p->num] == 1)
judge = false;
else if (Judge[p->num] == 0)
{
Judge[p->num] = 2;
B[b++] = p->num;
que.push(p->num);
}
p = p->next;
}
}
else
{
p = Graph[k].first;
while (p)
{
if (Judge[p->num] == 2)
judge = false;
else if (Judge[p->num] == 0)
{
Judge[p->num] = 1;
A[a++] = p->num;
que.push(p->num);
}
p = p->next;
}
}
}
}
return judge;
}
int main()
{
int x, y;
scanf("%d%d", &n, &m);
Init();
for (int i = 0; i < m; i++)
{
scanf("%d%d", &x, &y);
Insert(x, y);
}
bool key = Bfs();
if (key)
{
printf("%d\n", a);
for (int i = 0; i < a; i++)
printf("%d ", A[i]);
printf("\n%d\n", b);
for (int i = 0; i < b; i++)
printf("%d ", B[i]);
printf("\n");
}
else

4000
printf("-1\n");
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  ACM Codeforces